aboutsummaryrefslogtreecommitdiff
path: root/testsuite/bzcat.tests
diff options
context:
space:
mode:
authorDenys Vlasenko <vda.linux@googlemail.com>2011-10-31 01:05:16 +0100
committerDenys Vlasenko <vda.linux@googlemail.com>2011-10-31 01:05:16 +0100
commitc531b9a3e4a90fd7c91c78a6991e30bfe0134f34 (patch)
tree63883e7ad41456977664c0a4f2d3b36d980bebd7 /testsuite/bzcat.tests
parentb076193f741740886a6771cfe7750adb58ce18a0 (diff)
downloadbusybox-c531b9a3e4a90fd7c91c78a6991e30bfe0134f34.tar.gz
bzcat: fix unpacking of more than one file, and unpacking of zero-size bz2. Closes 4393
Signed-off-by: Denys Vlasenko <vda.linux@googlemail.com>
Diffstat (limited to 'testsuite/bzcat.tests')
-rwxr-xr-xtestsuite/bzcat.tests80
1 files changed, 27 insertions, 53 deletions
diff --git a/testsuite/bzcat.tests b/testsuite/bzcat.tests
index 5b4f3f4b3..c1d384464 100755
--- a/testsuite/bzcat.tests
+++ b/testsuite/bzcat.tests
@@ -1,54 +1,28 @@
#!/bin/sh
-
-FAILCOUNT=0
-
-ext=bz2
-
-bb="busybox "
-
-unset LC_ALL
-unset LC_MESSAGES
-unset LANG
-unset LANGUAGE
-
-hello_gz() {
- # Gzipped "HELLO\n"
- #_________________________ vvv vvv vvv vvv - mtime
- $ECHO -ne "\x1f\x8b\x08\x00\x85\x1d\xef\x45\x02\x03\xf3\x70\xf5\xf1\xf1\xe7"
- $ECHO -ne "\x02\x00\x6e\xd7\xac\xfd\x06\x00\x00\x00"
-}
-
-hello_bz2() {
- # Bzipped "HELLO\n"
- $ECHO -ne "\x42\x5a\x68\x39\x31\x41\x59\x26\x53\x59\x5b\xb8\xe8\xa3\x00\x00"
- $ECHO -ne "\x01\x44\x00\x00\x10\x02\x44\xa0\x00\x30\xcd\x00\xc3\x46\x29\x97"
- $ECHO -ne "\x17\x72\x45\x38\x50\x90\x5b\xb8\xe8\xa3"
-}
-
-prep() {
- rm -f t*
- hello_$ext >t1.$ext
- hello_$ext >t2.$ext
-}
-
-check() {
- eval $2 >t_actual 2>&1
- if $ECHO -ne "$expected" | cmp - t_actual; then
- echo "PASS: $1"
- else
- echo "FAIL: $1"
- FAILCOUNT=$((FAILCOUNT + 1))
- fi
-}
-
-mkdir testdir 2>/dev/null
-(
-cd testdir || { echo "cannot cd testdir!"; exit 1; }
-
-expected="HELLO\nok\n"
-prep; check "bzcat: dont delete src" "${bb}bzcat t2.bz2; test -f t2.bz2 && echo ok"
-
-)
-rm -rf testdir
-
-exit $((FAILCOUNT <= 255 ? FAILCOUNT : 255))
+# Copyright 2011 by Denys Vlasenko
+# Licensed under GPLv2, see file LICENSE in this source tree.
+
+. ./testing.sh
+
+# testing "test name" "command" "expected result" "file input" "stdin"
+
+# "input" file is bzipped file with "a\n" data
+testing "bzcat can print many files" \
+"$ECHO -ne '$hexdump' | bzcat input input; echo \$?" \
+"\
+a
+a
+0
+" "\
+\x42\x5a\x68\x39\x31\x41\x59\x26\x53\x59\x63\x3e\xd6\xe2\x00\x00\
+\x00\xc1\x00\x00\x10\x20\x00\x20\x00\x21\x00\x82\xb1\x77\x24\x53\
+\x85\x09\x06\x33\xed\x6e\x20\
+" ""
+
+# "input" file is bzipped zero byte file
+testing "bzcat can handle compressed zero-length bzip2 files" \
+"$ECHO -ne '$hexdump' | bzcat input input; echo \$?" \
+"0\n" \
+"\x42\x5a\x68\x39\x17\x72\x45\x38\x50\x90\x00\x00\x00\x00" ""
+
+exit $FAILCOUNT